Qwt User's Guide: QwtScaleEngine Class Reference

- Main Page
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# QwtScaleEngine Class Reference

Inheritance diagram for QwtScaleEngine:

[legend]
List of all members.

## Detailed Description

Base class for scale engines.

A scale engine trys to find "reasonable" ranges and step sizes for scales.

The layout of the scale can be varied with setAttribute().

Qwt offers implementations for logarithmic (log10) and linear scales. Contributions for other types of scale engines (date/time, log2 ... ) are welcome.

Definition at line 50 of file qwt_scale_engine.h.

## Public Types
enum | Attribute { NoAttribute = 0, IncludeReference = 1, Symmetric = 2, Floating = 4, Inverted = 8 }
## Public Member Functions
| QwtScaleEngine ()
virtual | ~QwtScaleEngine ()
void | setAttribute (Attribute, bool on=true)
bool | testAttribute (Attribute) const
void | setAttributes (int)
int | attributes () const
void | setReference (double reference)
double | reference () const
void | setMargins (double m1, double m2)
double | loMargin () const
double | hiMargin () const
virtual void | autoScale (int maxNumSteps, double &x1, double &x2, double &stepSize) const =0
virtual QwtScaleDiv | divideScale (double x1, double x2, int maxMajSteps, int maxMinSteps, double stepSize=0.0) const =0
virtual QwtScaleTransformation * | transformation () const =0
## Protected Member Functions
bool | contains (const QwtDoubleInterval &, double val) const
QwtValueList | strip (const QwtValueList &, const QwtDoubleInterval &) const
double | divideInterval (double interval, int numSteps) const
QwtDoubleInterval | buildInterval (double v) const

## Member Enumeration Documentation

enum QwtScaleEngine::Attribute

| see QwtScaleEngine::setOption, testOption Definition at line 54 of file qwt_scale_engine.h.

## Constructor & Destructor Documentation

QwtScaleEngine::QwtScaleEngine | ( |  | ) | `[explicit]`

| Ctor. Definition at line 169 of file qwt_scale_engine.cpp.

QwtScaleEngine::~QwtScaleEngine | ( |  | ) | `[virtual]`

| Dtor. Definition at line 176 of file qwt_scale_engine.cpp.

## Member Function Documentation

int QwtScaleEngine::attributes | ( |  | ) | const

| Return the scale attributes Definition at line 372 of file qwt_scale_engine.cpp. Referenced by QwtLog10ScaleEngine::divideScale().

virtual void QwtScaleEngine::autoScale | ( | int | maxNumSteps,
|  | double & | x1,
|  | double & | x2,
|  | double & | stepSize
| ) | const`[pure virtual]`

  | Align and divide an interval Parameters:
  | maxNumSteps | Max. number of steps
  | x1 | First limit of the interval (In/Out)
  | x2 | Second limit of the interval (In/Out)
  | stepSize | Step size (Return value)
Implemented in QwtLinearScaleEngine, and QwtLog10ScaleEngine.

QwtDoubleInterval QwtScaleEngine::buildInterval | ( | double | v | ) | const`[protected]`

| Build an interval for a value. In case of v == 0.0 the interval is [-0.5, 0.5], otherwide it is [0.5 * v, 1.5 * v] Definition at line 309 of file qwt_scale_engine.cpp. Referenced by QwtLog10ScaleEngine::autoScale(), and QwtLinearScaleEngine::autoScale().

bool QwtScaleEngine::contains | ( | const QwtDoubleInterval & | interval,
|  | double | value
| ) | const`[protected]`

  | Check if an interval "contains" a value Parameters:
  | interval | Interval
  | value | Value
See also: QwtScaleArithmetic::compareEps Definition at line 251 of file qwt_scale_engine.cpp. References QwtScaleArithmetic::compareEps(), QwtDoubleInterval::isValid(), QwtDoubleInterval::maxValue(), QwtDoubleInterval::minValue(), and QwtDoubleInterval::width(). Referenced by strip().

double QwtScaleEngine::divideInterval | ( | double | intervalSize,
|  | int | numSteps
| ) | const`[protected]`

  | Calculate a step size for an interval size Parameters:
  | intervalSize | Interval size
  | numSteps | Number of steps
Returns: Step size Definition at line 233 of file qwt_scale_engine.cpp. References QwtScaleArithmetic::ceil125(), and QwtScaleArithmetic::divideEps(). Referenced by QwtLog10ScaleEngine::autoScale(), QwtLinearScaleEngine::autoScale(), QwtLog10ScaleEngine::divideScale(), and QwtLinearScaleEngine::divideScale().

virtual QwtScaleDiv QwtScaleEngine::divideScale | ( | double | x1,
|  | double | x2,
|  | int | maxMajSteps,
|  | int | maxMinSteps,
|  | double | stepSize = `0.0`
| ) | const`[pure virtual]`

  | Calculate a scale division. Parameters:
  | x1 | First interval limit
  | x2 | Second interval limit
  | maxMajSteps | Maximum for the number of major steps
  | maxMinSteps | Maximum number of minor steps
  | stepSize | Step size. If stepSize == 0.0, the scaleEngine calculates one.
Implemented in QwtLinearScaleEngine, and QwtLog10ScaleEngine.

double QwtScaleEngine::hiMargin | ( |  | ) | const

| Returns: the margin at the upper end of the scale The default margin is 0. See also: QwtScaleEngine::setMargins() Definition at line 198 of file qwt_scale_engine.cpp. Referenced by QwtLog10ScaleEngine::autoScale(), QwtLinearScaleEngine::autoScale(), and QwtLog10ScaleEngine::divideScale().

double QwtScaleEngine::loMargin | ( |  | ) | const

| Returns: the margin at the lower end of the scale The default margin is 0. See also: QwtScaleEngine::setMargins() Definition at line 187 of file qwt_scale_engine.cpp. Referenced by QwtLog10ScaleEngine::autoScale(), QwtLinearScaleEngine::autoScale(), and QwtLog10ScaleEngine::divideScale().

double QwtScaleEngine::reference | ( |  | ) | const

| Returns: the reference value See also: QwtScaleEngine::setReference(), QwtScaleEngine::setOptions() Definition at line 393 of file qwt_scale_engine.cpp. Referenced by QwtLog10ScaleEngine::autoScale(), QwtLinearScaleEngine::autoScale(), and QwtLog10ScaleEngine::divideScale().

void QwtScaleEngine::setAttribute | ( | Attribute | attribute,
|  | bool | on = `true`
| ) |

  | Change a scale attribute Parameters:
  | attribute | Attribute to change
  | on | On/Off
The behaviour of the scale engine can be changed with the following attributes: QwtScaleEngine::IncludeReference Build a scale which includes the reference value. QwtScaleEngine::Symmetric Build a scale which is symmetric to the reference value. QwtScaleEngine::Floating The endpoints of the scale are supposed to be equal the outmost included values plus the specified margins (see setMargins()). If this attribute is not* set, the endpoints of the scale will be integer multiples of the step size. QwtScaleEngine::Inverted Turn the scale upside down. See also: QwtScaleEngine::testAttribute() Definition at line 339 of file qwt_scale_engine.cpp.

void QwtScaleEngine::setAttributes | ( | int | attributes | ) |

  | Change the scale attribute Parameters:
  | attributes | Set scale attributes
See also: QwtScaleEngine::attributes() Definition at line 364 of file qwt_scale_engine.cpp. Referenced by QwtLog10ScaleEngine::divideScale().

void QwtScaleEngine::setMargins | ( | double | mlo,
|  | double | mhi
| ) |

  | Specify margins at the scale's endpoints. Parameters:
  | mlo | minimum distance between the scale's lower boundary and the smallest enclosed value
  | mhi | minimum distance between the scale's upper boundary and the greatest enclosed value
Margins can be used to leave a minimum amount of space between the enclosed intervals and the boundaries of the scale. Warning: QwtLog10ScaleEngine measures the margins in decades. See also: QwtScaleEngine::hiMargin, QwtScaleEngine::loMargin Definition at line 219 of file qwt_scale_engine.cpp. Referenced by QwtLog10ScaleEngine::divideScale().

void QwtScaleEngine::setReference | ( | double | r | ) |

  | Specify a reference point. Parameters:
  | r | new reference value
The reference point is needed if options IncludeRef or Symmetric are active. Its default value is 0.0. Definition at line 384 of file qwt_scale_engine.cpp. Referenced by QwtLog10ScaleEngine::divideScale().

QwtValueList QwtScaleEngine::strip | ( | const QwtValueList & | ticks,
|  | const QwtDoubleInterval & | interval
| ) | const`[protected]`

  | Remove ticks from a list, that are not inside an interval Parameters:
  | ticks | Tick list
  | interval | Interval
Returns: Stripped tick list Definition at line 280 of file qwt_scale_engine.cpp. References contains(), and QwtDoubleInterval::isValid().

bool QwtScaleEngine::testAttribute | ( | Attribute | attribute | ) | const

  | Check if a attribute is set. Parameters:
  | attribute | Attribute to be tested
See also: QwtScaleEngine::setAttribute() for a description of the possible options. Definition at line 353 of file qwt_scale_engine.cpp. Referenced by QwtLog10ScaleEngine::autoScale(), and QwtLinearScaleEngine::autoScale().

virtual QwtScaleTransformation* QwtScaleEngine::transformation | ( |  | ) | const`[pure virtual]`

| Returns: a transformation Implemented in QwtLinearScaleEngine, and QwtLog10ScaleEngine.